import Vue from 'vue'
import Vuex from 'vuex'
/**
 * [ Store ]
 */
import AppPurchases from '@/store/AppPurchases'
/**
 * [ Modules]
 */
import paymentsPurchasesDate from '@/store/modules/PaymentsPurchasesDate'
import paymentsPurchasesUser from '@/store/modules/PaymentsPurchasesUser'
import paymentsPurchasesCompany from '@/store/modules/PaymentsPurchasesCompany'
import paymentsPurchasesSupplier from '@/store/modules/PaymentsPurchasesSupplier'
import paymentsPurchasesJournals from '@/store/modules/PaymentsPurchasesJournals'
import paymentsPurchasesCurrencies from '@/store/modules/PaymentsPurchasesCurrencies'
import supplierInvoices from '@/store/modules/SupplierInvoices'
import supplierMoveLines from '@/store/modules/SupplierMoveLines'
import supplierPayments from '@/store/modules/supplierPayments'
import PaymentsPurchasesBank from '@/store/modules/PaymentsPurchasesBank'
import PaymentsPurchasesBankType from '@/store/modules/PaymentsPurchasesBankType'
import PaymentsPurchasesBankPayments from '@/store/modules/PaymentsPurchasesBankPayments'

Vue.use(Vuex)

const store = new Vuex.Store({
    ...AppPurchases,
    modules: {
        paymentsPurchasesDate,
        paymentsPurchasesUser,
        paymentsPurchasesCompany,
        paymentsPurchasesSupplier,
        paymentsPurchasesJournals,
        paymentsPurchasesCurrencies,
        supplierInvoices,
        supplierMoveLines,
        supplierPayments,
        PaymentsPurchasesBank,
        PaymentsPurchasesBankType,
        PaymentsPurchasesBankPayments
    }
})

export default store
