const initialState = {
    company: [],
    currencyCompany: []
}

const state = {
    company: initialState.company,
    currencyCompany: initialState.currencyCompany
}

const getters = {
    /**
     * [company description]
     */
    company ( state ) {
        return state.company
    },
    /**
     * [currencyCompany description]
     */
    currencyCompany ( state ) {
        return state.currencyCompany
    }
}

const mutations = {
    /**
     * [company description]
     */
    setCompanyUser ( state, payload ){
        state.company = payload
    },
    /**
     * [currencyCompany description]
    */
    setCurrencyCompany (state, payload ) {
        state.currencyCompany = payload
    }
}

const actions = {
    /**
     * [INIT_COMPANY_USER]
     */
    initCompanyUser ({ commit }, payload ) {
        commit('setCompanyUser', payload.company)
        commit('setCurrencyCompany', payload.currency)
    },
    /**
     * [resetPaymentsPurchasesCompany]
     */
    resetPaymentsPurchasesCompany ({ commit }) {
        commit('setCompanyUser', [])
        commit('setCurrencyCompany', [])
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
