const initialState = {
    currency: [],
    loadingCurrency: false
}

const state = {
    currency: initialState.currency,
    loadingCurrency: initialState.loadingCurrency
}

const getters = {
    /**
     * [currency description]
     */
    currency ( state ) {
        return state.currency
    },
    /**
     * [loadingCurrency description]
     */
    loadingCurrency ( state ) {
        return state.loadingCurrency
    }
}

const mutations = {
    /**
     * [setCurrencies description]
     */
    setCurrencies ( state, payload ){
        state.currency = payload
    },
    /**
     * [setLoadingCurrencies description]
     */
    setLoadingCurrencies ( state, payload ) {
        state.loadingCurrency = !!payload
    }
}

const actions = {
    /**
     * [initPaymentsPurchasesCurrencies description]
     */
    initPaymentsPurchasesCurrencies ({ commit }, payload) {
        commit('setCurrencies', payload)
        commit('setLoadingCurrencies', payload)
    },
    /**
     * [RESET_PAYMENTS_PURCHASES_CURRENCIES]
     */
    resetPaymentsPurchasesCurrencies ({ commit }) {
        commit('setCurrencies', [])
        commit('setLoadingCurrencies', false)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
