const initialState = {
    date: null,
    loadingDate: false
}

const state = {
    date: initialState.date,
    loadingDate: initialState.loadingDate
}

const getters = {
    /**
     * [date description]
     */
    date (state) {
        return state.date
    },
    /**
     * [loadingDate description]
     */
    loadingDate (state) {
        return state.loadingDate
    }
}

const mutations = {
    /**
     * [setDate description]
     */
    setDate (state, payload) {
        state.date = payload
    },
    /**
     * [loadingDate description]
     */
    setLoadingDate (state, payload) {
        state.loadingDate = !!payload
    }
}

const actions = {
    /**
     * [INIT_PAYMENTS_PURCHASES_DATE]
     */
    initPaymentsPurchasesDate ({ commit }, payload) {
        commit('setDate', payload)
        commit('setLoadingDate', payload)
    },
    /**
     * [RESET_PAYMENTS_PURCHASES_DATE]
     */
    resetPaymentsPurchasesDate ({ commit }) {
        commit('setDate', [] )
        commit('setLoadingDate', false)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
