const initialState = {
    journals : null,
    loadingJournals: false
}

const state = {
    journals: initialState.journals,
    loadingJournals: initialState.loadingJournals
}

const getters  = {
    /**
     * [journals description]
     */
    journals ( state ) {
        return state.journals
    },
    /**
     * [loadingJournals description]
     */
    loadingJournals( state ) {
        return state.loadingJournals
    }
}

const mutations = {
    /**
     * [journals description]
     */
    setJournals (state, payload ) {
        state.journals = payload
    },
    /**
     * [loadingJournals description]
     */
    setLoadingJournals (state, payload) {
        state.loadingJournals = !!payload
    }
}

 const actions = {
     /**
      * [INIT_PAYMENTS_PURCHASES_JOURNALS]
      */
    initPaymentsPurchasesJournals ({ commit, dispatch }, payload) {
        commit('setJournals', payload)
        commit('setLoadingJournals', payload)
        dispatch('initPaymentsJournals', payload)
    },
     /**
      * [RESET_PAYMENTS_PURCHASES_JOURNALS]
      */
    resetPaymentsPurchasesJournals ({ commit }) {
        commit('setJournals', [])
        commit('setLoadingJournals', false)
    }
 }

 export default {
     state,
     getters,
     mutations,
     actions
 }
