const initialState = {
    user: [],
    loadingUser: false
}

const state = {
    user: initialState.user,
    loadingUser: initialState.loadingUser
}

const getters = {
    /**
     * [user description]
     */
    user (state) {
        return state.user
    },
    /**
     * [loadingUser description]
     */
    loadingUser (state) {
        return state.loadingUser
    }
}

const mutations = {
    /**
     * [user description]
     */
    setUser (state, payload) {
        state.user = payload
    },
    /**
     * [loadingUser description]
     */
    setLoadingUser (state, payload) {
        state.loadingUser = !!payload
    }
}

const actions = {
    /**
     * [initPaymentsPurchasesUser description]
     */
    initPaymentsPurchasesUser ({ commit, dispatch }, payload) {
        commit('setUser', payload)
        commit('setLoadingUser', payload)
        dispatch('initCompanyUser', payload)
    },
    /**
     *  [RESET_PAYMENTS_PURCHASES_USER]
     */
    resetPaymentsPurchasesUser ({ commit }) {
        commit('setUser', [])
        commit('setLoadingUser', false)
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
