const initialState = {
    supplierInvoices: [],
    filterInvoices: [],
    selectedInvoices: null,
    currencyInvoice :[]
}
const state = {
    supplierInvoices: initialState.supplierInvoices,
    filterInvoices: initialState.filterInvoices,
    selectedInvoices: initialState.selectedInvoices,
    currencyInvoice: initialState.currencyInvoice
}
const getters = {
    /**
     * [supplierInvoices description]
     */
    supplierInvoices (state) {
        return state.supplierInvoices
    },
    /**
     * [filterInvoices description]
     */
    supplierInvoicesVisibles ( state ) {
        return state.filterInvoices.length === 0 ? state.supplierInvoices :  state.filterInvoices
    },
    /**
     * [selectedInvoices description]
     */
    selectedInvoices ( state ) {
        return state.selectedInvoices
    },
    /**
     * [currencyInvoice description]
     */
    currencyInvoice ( state ) {
        return state.currencyInvoice
    }
}

const mutations = {
    /**
     * [Invoices description]
     */
    setSupplierInvoices (state, payload ) {
            state.supplierInvoices = payload
    },
    /**
     * [selectedInvoices description]
     */
    setSelectedSupplierInvoices ( state, payload ) {
        state.selectedInvoices= payload
    },
    /**
     * [filterInvoices description]
     */
    setFilterSupplierInvoices ( state, payload ) {
        state.filterInvoices = payload
    },
    /**
     * [mode description]
     */
    setMoveInInvoice (state, payload) {
        if (payload.mode === 'full') {
            payload.moveLines.forEach(moves => {
                let movesFound = state.selectedInvoices.moveLines.find(item => item.id === moves.id)
                if (movesFound) return
                state.selectedInvoices.moveLines = [moves, ...state.selectedInvoices.moveLines]
            })
        } else {
            let movesFound = state.selectedInvoices.moveLines.find(item => item.id === payload.moveLines.id)
            if (movesFound) return
            state.selectedInvoices.moveLines = [payload.moveLines, ...state.selectedInvoices.moveLines]
        }
    },
    /**
     * [currencyInvoice description]
     */
    setCurrencyInvoice ( state, payload) {
        state.currencyInvoice = payload
    }
}
const actions = {
    /**
     * [INIT_SUPPLIER_INVOICES]
     */
    initSupplierInvoices ({ commit }, payload ) {
        commit('setSupplierInvoices', payload)
    },
    /**
     * [FILTER_SUPPLIER_INVOICES]
     */
    filterSupplierInvoices ({ commit }, payload ) {
        commit('setFilterSupplierInvoices', payload)
    },
    /**
     * [SELECT_SUPPLIER_INVOICES]
     */
    selectSupplierInvoices ({commit, dispatch}, payload) {
        commit('setSelectedSupplierInvoices', payload)
        commit('setCurrencyInvoice', payload.currencyInvoice)

        dispatch('initSupplierMoveLines', payload.moveLines)
    },
    /**
     * [ADD_MOVE_IN_INVOICE]
     */
    addMoveInInvoice ({ commit },payload ) {
        commit('setMoveInInvoice', payload)
    },
    /**
     * [RESET_SUPPLIER_INVOICES]
     */
    resetSupplierInvoices ({ commit }) {
        commit('setSupplierInvoices', [])
        commit('setSelectedSupplierInvoices', null)
        commit('setFilterSupplierInvoices', [])
        commit('setCurrencyInvoice', [])
    }
}

export default {
    state,
    getters,
    mutations,
    actions
}
