const initialState = {
    paymentsJournals: [],
    paymentsSelectedJournal: null,
    paymentsMoveLines: [],
    paymentsCurrencyAmount: [],
    paymentsCurrencyJournal: null,
    paymentsTotal: 0,
    paidTotal: 0,
    paymentsReturned: 0,
    selectedPaymentsBank: null,
    selectedPaymentsBankType: null,
    paymentsBankRef: '',
    paymentsBankDateMaturity: '',
    paymentsBankNumberCta: '',
    paymentsBankNameHolder: '',
    paymentsBankAmount: 0,
    recidualAMountPayment: 0,
    showBankPaymentModal: false
}

const state = {
    paymentsJournals: initialState.paymentsJournals,
    paymentsSelectedJournal: initialState.paymentsSelectedJournal,
    paymentsMoveLines: initialState.paymentsMoveLines,
    paymentsCurrencyAmount : initialState.paymentsCurrencyAmount,
    paymentsCurrencyJournal: initialState.paymentsCurrencyJournal,
    paymentsTotal: initialState.paymentsTotal,
    paidTotal: initialState.paidTotal,
    paymentsReturned: initialState.paymentsReturned,
    selectedPaymentsBank: initialState.selectedPaymentsBank,
    selectedPaymentsBankType: initialState.selectedPaymentsBankType,
    paymentsBankRef: initialState.paymentsBankRef,
    paymentsBankDateMaturity: initialState.paymentsBankDateMaturity,
    paymentsBankNumberCta: initialState.paymentsBankNumberCta,
    paymentsBankNameHolder: initialState.paymentsBankNameHolder,
    numberChBankId: initialState.numberChBankId,
    paymentsBankAmount: initialState.paymentsBankAmount,
    recidualAMountPayment: initialState.recidualAMountPayment,
    showBankPaymentModal: initialState.showBankPaymentModal
}

const getters = {
    /**
     * [paymentsJournals description]
     */
    paymentsJournals ( state ) {
            return state.paymentsJournals
    },
    /**
     * [paymentsSelectedJournal description]
     */
    paymentsSelectedJournal ( state ) {
        return state.paymentsSelectedJournal
    },
    /**
     * [paymentsMoveLines description]
     */
    paymentsMoveLines ( state ) {
        return state.paymentsMoveLines
    },
    /**
     * [paymentsCurrencyAmount description]
     */
    paymentsCurrencyAmount ( state ) {
        return state.paymentsCurrencyAmount
    },
    /**
     * [paymentsTotal description]
     */
    paymentsTotal ( state ) {
        return state.paymentsTotal
    },
    /**
     * [paymentsReturned description]
     */
    paymentsReturned ( state ) {
        return state.paymentsReturned
    },
    /**
     * [paidTotal description]
     */
    paidTotal ( state ) {
        return state.paidTotal
    },
    /**
     * [paymentsCurrencyJournal description]
     */
    paymentsCurrencyJournal ( state ) {
        return state.paymentsCurrencyJournal
    },
    /**
     * [selectedPaymentsBank description]
     */
    selectedPaymentsBank ( state ) {
        return state.selectedPaymentsBank
    },
    /**
     * [selectedPaymentsBankType description]
     */
    selectedPaymentsBankType ( state ) {
        return state.selectedPaymentsBankType
    },
    /**
     * [paymentsBankRef description]
     *
     */
    paymentsBankRef ( state ) {
        return state.paymentsBankRef
    },
    /**
     * [paymentsBankDateMaturity description]
     */
    paymentsBankDateMaturity ( state ) {
        return state.paymentsBankDateMaturity
    },
    /**
     * [paymentsBankNumberCta description]
     */
    paymentsBankNumberCta ( state ) {
        return state.paymentsBankNumberCta
    },
    /**
     * [paymentsBankNameHolder description]
     */
    paymentsBankNameHolder ( state ) {
        return state.paymentsBankNameHolder
    },
    /**
     * [numberChBankId description]
     */
    numberChBankId ( state ) {
        return state.numberChBankId
    },
    /**
     * [paymentsBankAmount description]
     */
    paymentsBankAmount (state ) {
        return state.paymentsBankAmount
    },
    /**
     * [recidualAMountPayment description]
     */
    recidualAMountPayment ( state ) {
        return state.recidualAMountPayment
    },
    /**
     * [showBankPaymentModal description]
     */
    showBankPaymentModal ( state ) {
        return state.showBankPaymentModal
    }
}

const mutations = {
    /**
     * [paymentsJournals description]
     */
    setPaymentsJournals ( state, payload ){
        state.paymentsJournals = payload
    },
    /**
     * [paymentsSelectedJournal description]
     */
    selectedPaymentsJournals ( state, payload ) {
        state.paymentsSelectedJournal =  payload
    },
    /**
     * [paymentsMoveLines description]
     */
    setAddPaymentsMoveLines (state, payload) {
        state.paymentsMoveLines = [payload, ...state.paymentsMoveLines]
    },
    /**
     * [actions description]
     */
    setRemovePaymentsMoveLines (state, payload) {
        if (payload.mode === 'full') {
            payload.moveLines.forEach(moves => {
                // Remove Payments
                let movesPaymentsIndex = state.paymentsMoveLines.findIndex(item => item.id === moves.id)
                state.paymentsMoveLines.splice(movesPaymentsIndex)
            })
        } else {
            // Remove Payments
            let movesPaymentsIndex = state.paymentsMoveLines.findIndex(item => item.id === payload.moveLines.id)
            state.paymentsMoveLines.splice(movesPaymentsIndex, 1)
        }
    },
    /**
     * [actions description]
     */
    calculateCurrencyAmount ( state, payload ) {
        let currency = payload.currency
        let paymentsMoveLines = payload.paymentsMoveLines
        let paymentsCurrencyAmount = []

        currency.forEach(item => {
            let amount = 0
            paymentsMoveLines.forEach( currency => {
                let currencyMoveLine = currency.currencyAmount.find(move => move.id === item.id)
                amount = amount + currencyMoveLine.amountCurencyResidual
            })
            paymentsCurrencyAmount.push({
                id: item.id,
                symbolCurrency: item.symbol,
                amount: amount,
                symbol: ' ',
                position: 'before',
                thousandsSeparator: item.thousandsSeparator,
                decimalSeparator: item.decimalSeparator,
                decimalPlaces: item.decimalPlaces,
                rateSilent: item.rateSilent
            })
        })
        state.paymentsCurrencyAmount = paymentsCurrencyAmount
    },
    /**
     * [actions description]
     */
    calculatePaymentsTotal ( state, payload){
        let currencyJournal = payload.paymentsCurrencyAmount.find(item => item.id ===payload.currency.id)
        let total = 0
        if (currencyJournal)
            total = currencyJournal.amount
        state.paymentsTotal = total
    },
    /**
     * [paidTotal description]
     */
    setPaidTotal (state, payload) {
        state.paidTotal = payload
    },
    /**
     * [paymentsCurrencyJournal description]
     */
    setPaymentsCurrencyJournal ( state, payload ){
        state.paymentsCurrencyJournal = payload
    },
    /**
     * [selectedPaymentsBank description]
     */
    selectedPaymentsPurchasesBank (state, payload){
        state.selectedPaymentsBank = payload
    },
    /**
     * [selectedPaymentsBankType description]
     */
    selectedPaymentsPurchasesBankType (state, payload){
        state.selectedPaymentsBankType = payload
    },
    /**
     * [paymentsBankRef description]
     */
    setPaymentsPurchasesBankRef (state, payload){
        state.paymentsBankRef = payload
    },
    /**
     * [paymentsBankDateMaturity description]
     */
    setPaymentsPurchasesBankDateMaturity (state, payload){
        state.paymentsBankDateMaturity = payload
    },
    /**
     * [paymentsBankNumberCta description]
     */
    setPaymentsPurchasesBankNumberCta (state, payload){
        state.paymentsBankNumberCta = payload
    },
    /**
     * [paymentsBankNameHolder description]
     */
    setPaymentsPurchasesBankNameHolder (state, payload){
        state.paymentsBankNameHolder = payload
    },
    /**
     * [numberChBankId description]
     */
    // setNumberChBank (state, paylod) {
    //     state.numberChBankId = paylod
    // },
    /**
     * [actions description]
     */
    setShowBankPaymentModal (state, payload) {
        state.showBankPaymentModal = payload
    },
    /**
     * [setPaymentsBankAmount description]
     */
    setPaymentsBankAmount (state, payload) {
        state.paymentsBankAmount = payload
    },
    /**
     * [setRecidualAmountPayment description]
     */
    setRecidualAmountPayment (state, payload) {
        state.recidualAMountPayment =  payload
    }
}

const actions = {
    /**
     * [INIT_PAYMENTS_JOURNALS]
     */
    initPaymentsJournals ({ commit }, payload ) {
        commit('setPaymentsJournals', payload)
    },
    /**
     * [SELECT_PAYMENTS_JOURNALS]
     */
    selectPaymentsJournals ({ commit, getters }, payload ) {
        commit('selectedPaymentsJournals', payload)

        let currency = []
        if (payload.currency.id){
            currency = payload.currency
        } else {
            currency = getters.currencyCompany
        }
        commit('calculatePaymentsTotal', {
            paymentsCurrencyAmount: getters.paymentsCurrencyAmount,
            currency: currency
        })

        commit('setPaymentsCurrencyJournal', currency)

        if (payload.type === 'bank') {
            commit('setShowBankPaymentModal', !!getters.bank.length && !!getters.bankType.length)
        }
    },
    /**
     * [paymentsCurrencyAmount description]
     */
    resetSelectedJournalPayments ({ commit }) {
        commit('selectedPaymentsJournals', [])
        commit('calculatePaymentsTotal', {
            paymentsCurrencyAmount: [],
            currency: []
        })
        commit('setPaymentsCurrencyJournal', [])
    },
    /**
     * [ADD_PAYMENTS_MOVE_LINES]
     */
    addPaymentsMoveLines ({ commit, getters, dispatch }, payload ) {
        commit('setAddPaymentsMoveLines', payload)
        commit('calculateCurrencyAmount', {
            paymentsMoveLines: getters.paymentsMoveLines,
            currency: getters.currency
        })
        dispatch('resetSelectedJournalPayments', [])
    },
    /**
     * [REMOVE_PAYMENTS_MOVE_LINES]
     */
    removePaymentsMoveLines ({ commit, getters, dispatch }, payload ) {
        commit('setRemovePaymentsMoveLines', payload)
        commit('calculateCurrencyAmount', {
            paymentsMoveLines: getters.paymentsMoveLines,
            currency: getters.currency
        })
        dispatch('resetSelectedJournalPayments', [])

    },
    /**
     * [CHANGE_INITIAL_PAID]
     */
    changeInitialPaid ({ commit },payload) {
        commit('setPaidTotal', payload)
    },
    /**
     * [RESET_SUPPLIER_PAYMENTS]
     */
    resetSupplierPayments ({ commit, getters }) {
        commit('setPaymentsJournals', [])
        commit('selectedPaymentsJournals', [])
        commit('setRemovePaymentsMoveLines', {
            mode: 'full',
            moveLines: getters.paymentsMoveLines
        })
        commit('calculateCurrencyAmount', {
            currency: [],
            paymentsMoveLines: []
        })
        commit('setPaymentsCurrencyJournal', [])
        commit('calculatePaymentsTotal', {
            paymentsCurrencyAmount: [],
            currency: []
        })
        commit('setPaidTotal' , 0)

        commit('selectedPaymentsPurchasesBank', null)
        commit('selectedPaymentsPurchasesBankType', null)
        commit('setPaymentsPurchasesBankRef', '')
        commit('setPaymentsPurchasesBankDateMaturity',  '')
        commit('setPaymentsPurchasesBankNumberCta', '')
        commit('setPaymentsPurchasesBankNameHolder', '')
        commit('setNumberChBank', null)

    },
    /**
     * [SELECT_PAYMENTS_PURCHASES_BANK]
     */
    selectPaymentsPurchasesBank ({ commit }, payload ){
        commit('selectedPaymentsPurchasesBank', payload)
    },
    /**
     * [SELECT_PAYMENTS_PURCHASES_BANK_TYPE]
     */
    selectPaymentsPurchasesBankType ({ commit }, payload ){
        commit('selectedPaymentsPurchasesBankType', payload)
    },
    /**
     * [CHANGE_PAYMENTS_PURCHASES_BANK_REF]
     */
    change_paymentsPurchasesBankRef ({ commit }, payload ){
        commit('setPaymentsPurchasesBankRef', payload)
    },
    /**
     * [CHANGE_PAYMENTS_PURCHASES_BANK_DATE_MATURITY]
     */
    changePaymentsPurchasesBankDateMaturity ({ commit }, payload ){
        commit('setPaymentsPurchasesBankDateMaturity', payload)
    },
    /**
     * [CHANGE_PAYMENTS_PURCHASES_BANK_NUMBER_CTA]
     */
    changePaymentsPurchasesBankNumberCta ({ commit }, payload ){
        commit('setPaymentsPurchasesBankNumberCta', payload)
    },
    /**
     * [CHANGE_PAYMENTS_PURCHASES_BANK_NAME_HOLDER]
     */
    changePaymentsPurchasesBankNameHolder ({ commit }, payload ){
        commit('setPaymentsPurchasesBankNameHolder', payload)
    },
    /**
     * [bank description]
     */
    filterNumberChBank( {commit }, payload) {
        let bank = null
        let bankType = null
        let dateMaturity = ''
        let numberCta = ''
        let nameHolder = ''
        let number = null

        if (payload.length === 1) {
            bank = payload[0].bankId
            bankType = payload[0].bankPaymentsType
            dateMaturity = payload[0].dateMaturity
            numberCta = payload[0].numberCta
            nameHolder = payload[0].nameHolder
            number = payload[0].id
        }
        /* Actualizar  datos */
        commit('setNumberChBank', number)
        commit('selectedPaymentsPurchasesBank', bank)
        commit('selectedPaymentsPurchasesBankType', bankType)
        commit('setPaymentsPurchasesBankDateMaturity',  dateMaturity)
        commit('setPaymentsPurchasesBankNumberCta', numberCta)
        commit('setPaymentsPurchasesBankNameHolder', nameHolder)

    },
    /**
     * [RESET_SUPPLIER_PAYMENTS_BANK]
     */
    resetSupplierPaymentsBank ({ commit, dispatch }, payload) {
        commit('selectedPaymentsPurchasesBank', null)
        commit('selectedPaymentsPurchasesBankType', null)
        commit('setPaymentsPurchasesBankRef', '')
        commit('setPaymentsPurchasesBankDateMaturity',  '')
        commit('setPaymentsPurchasesBankNumberCta', '')
        commit('setPaymentsPurchasesBankNameHolder', '')
        commit('setNumberChBank', null)
        dispatch('resetSelectedJournalPayments')
    },
    /**
     * [amount description]
     */
    submitBankPayments ( { commit, dispatch, getters }, payload){
        if (!payload.bank){
            dispatch('resetPaymentsBank')
            return
        }
        if (payload.amountReceipt <= 0 ){
            dispatch('paymentsNotify','Cheque sin saldo')
            dispatch('resetPaymentsBank')
            return
        }

        commit('selectedPaymentsPurchasesBank', payload.bank)
        commit('selectedPaymentsPurchasesBankType', payload.bankType)
        commit('setPaymentsPurchasesBankRef', payload.number)
        commit('setPaymentsPurchasesBankDateMaturity', payload.dateMaturity)
        commit('setPaymentsPurchasesBankNumberCta', payload.numberCta)
        commit('setPaymentsPurchasesBankNameHolder', payload.nameHolder)
        commit('setPaymentsBankAmount', payload.amountTotal)
        commit('setRecidualAmountPayment', payload.amountReceipt)
        commit('setShowBankPaymentModal', false)

        let amount = payload.amountReceipt

        if (amount > getters.paymentCurrencyTotal)
            amount = getters.paymentCurrencyTotal

        commit('setPaidTotal', amount)
    },

    resetPaymentsBank ({commit, dispatch}) {
        commit('selectedPaymentsPurchasesBank', null)
        commit('selectedPaymentsPurchasesBankType', null)
        commit('setPaymentsPurchasesBankRef', '')
        commit('setPaymentsPurchasesBankDateMaturity', '')
        commit('setPaymentsPurchasesBankNumberCta', '')
        commit('setPaymentsPurchasesBankNameHolder', '')
        commit('setPaymentsBankAmount', 0)
        commit('setRecidualAmountPayment', 0)

        commit('setPaidTotal', 0)
        commit('setCurrencyTotal', 0)

        dispatch('resetSelectedJournal')

        commit('setShowBankPaymentModal', false)
    },
}

export default {
    state,
    getters,
    mutations,
    actions
}
